# Vray object id script by Martijn Grootendorst 13-10-2010
# www.uncinc.nl
#
# Script to change vray object Id's
#
# Usage: select your surfaces, then call vrayObjIdchange()
# this will put the selection in a list and present it to you in an interface, you can directly edit in the intFields
# when it doesn't find the objid attr it will show "666" as soon as you change this number it will automatically add the attr
# I will continue to improve this script when I have time or feel the need, feel free to edit as you wish.
# ofcourse you can use this for any attribute
import maya.cmds as cmds
import maya.mel


def changeVrayAttr():

	listSelection = cmds.ls(selection=True)
	listShapes = cmds.listRelatives(shapes=True, ni=True)	
	for i in range(0, len(listShapes)):
		if cmds.objExists(listShapes[i]+".vrayObjectID"):
			value = cmds.intField("intFieldNo"+str(i), query=True, value=True)
			cmds.setAttr(listShapes[i]+".vrayObjectID", value)
		else:
			print listShapes[i]+".vrayObjectID", "  doesn't exist, i'll make one :P"
			maya.mel.eval("vrayAddAttr "+listShapes[i]+" vrayObjectID;")
			value = cmds.intField("intFieldNo"+str(i), query=True, value=True)
			cmds.setAttr(listShapes[i]+".vrayObjectID", value)
			


def vrayObjIdchange():
	text = []
	objID = []
	intFieldList = []
	listSelection = cmds.ls(selection=True)
	listShapes = cmds.listRelatives(shapes=True, ni=True)
	
	if (cmds.window("vrayObjUI", ex=True)):
		cmds.deleteUI( "vrayObjUI", window=True )
		
	window = cmds.window("vrayObjUI",sizeable=False, title=str(len(listShapes))+" Objects in List" )
	columnLayout = cmds.columnLayout(cw=200)
	cmds.setParent(columnLayout)
	#print listShapes
	#print len(listShapes)
	
	for i in range(0, len(listShapes)):
		#print "i is now", i
		cmds.rowLayout( numberOfColumns=2, columnWidth2=(400, 50), adjustableColumn=2, columnAlign=(1, 'left'), columnAttach=[(1, 'both', 0), (2, 'both', 0)] )
		cmds.text(listShapes[i]+".vrayObjectID")
		intFieldName = "intFieldNo"+str(i)
		if cmds.objExists(listShapes[i]+".vrayObjectID"):
			objID.insert(i, cmds.getAttr(listShapes[i]+".vrayObjectID"))			
		else:
			objID.insert(i, 666)		
		intFieldList.insert(i, cmds.intField(intFieldName, value=objID[i], ed=True, cc=lambda x:changeVrayAttr()))
		cmds.setParent(columnLayout)
		
	
	cmds.showWindow(window)

		    
